package com.ejie.ab79.control.inspecciones;

import java.util.List;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.ResponseStatus;

import com.ejie.ab79.model.inspecciones.Agrupaciones;
import com.ejie.ab79.service.inspecciones.AgrupacionesService;
import com.ejie.x38.control.bind.annotation.RequestJsonBody;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableResponseDto;

/**
 * AgrupacionesController  
 * 
 *  
 */

@Controller
@RequestMapping(value = "/agrupaciones")

public class AgrupacionesController {

	private static final Logger logger = LoggerFactory.getLogger(AgrupacionesController.class);

	@Autowired
	private AgrupacionesService agrupacionesService;

	/*
	 * OPERACIONES CRUD (Create, Read, Update, Delete)
	 * 
	 */

	/**
	 * Operacion CRUD Read. Devuelve el bean correspondiente al identificador
	 * indicado.
	 * 
	 * @param idAgrupacion
	 *            Integer
	 * @return Agrupaciones Objeto correspondiente al identificador indicado.
	 */
	@RequestMapping(value = "/{idAgrupacion}", method = RequestMethod.GET)
	public @ResponseBody Agrupaciones get(@PathVariable Integer idAgrupacion) {
		Agrupaciones agrupaciones = new Agrupaciones();
		agrupaciones.setIdAgrupacion(idAgrupacion);
		agrupaciones = this.agrupacionesService.find(agrupaciones);
		AgrupacionesController.logger.info("[GET - findBy_PK] : Obtener Agrupaciones por PK");
		return agrupaciones;
	}

	/**
	 * Devuelve una lista de beans correspondientes a los valores de filtrados
	 * indicados en el objeto pasado como parametro.
	 *
	 * @param filterAgrupaciones
	 *            Agrupaciones Objeto que contiene los parametros de filtrado
	 *            utilizados en la busqueda.
	 * @return List<Agrupaciones> Lista de objetos correspondientes a la
	 *         busqueda realizada.
	 */
	@RequestMapping(method = RequestMethod.GET)
	public @ResponseBody List<Agrupaciones> getAll(@ModelAttribute Agrupaciones filterAgrupaciones) {
		AgrupacionesController.logger.info("[GET - find_ALL] : Obtener Agrupaciones por filtro");
		return this.agrupacionesService.findAll(filterAgrupaciones, null);
	}

	/**
	 * Operacion CRUD Edit. Modificacion del bean indicado.
	 *
	 * @param agrupaciones
	 *            Agrupaciones Bean que contiene la informacion a modificar.
	 * @return Agrupaciones Bean resultante de la modificacion.
	 */
	@RequestMapping(method = RequestMethod.PUT)
	public @ResponseBody Agrupaciones edit(@RequestBody Agrupaciones agrupaciones) {
		Agrupaciones agrupacionesAux = this.agrupacionesService.update(agrupaciones);
		AgrupacionesController.logger.info("[PUT] : Agrupaciones actualizado correctamente");
		return agrupacionesAux;
	}

	/**
	 * Operacion CRUD Create. Creacion de un nuevo registro a partir del bean
	 * indicado.
	 *
	 * @param agrupaciones
	 *            Agrupaciones Bean que contiene la informacion con la que se va
	 *            a crear el nuevo registro.
	 * @return Agrupaciones Bean resultante del proceso de creacion.
	 */
	@RequestMapping(method = RequestMethod.POST)
	public @ResponseBody Agrupaciones add(@RequestBody Agrupaciones agrupaciones) {
		Agrupaciones agrupacionesAux = this.agrupacionesService.add(agrupaciones);
		AgrupacionesController.logger.info("[POST] : Agrupaciones insertado correctamente");
		return agrupacionesAux;
	}

	/**
	 * Operacion CRUD Delete. Borrado del registro correspondiente al
	 * identificador especificado.
	 *
	 * @param idAgrupacion
	 *            Integer Identificador del objeto que se desea eliminar.
	 * @return Agrupaciones Bean eliminado.
	 */
	@RequestMapping(value = "/{idAgrupacion}", method = RequestMethod.DELETE)
	@ResponseStatus(value = HttpStatus.OK)
	public @ResponseBody Agrupaciones remove(@PathVariable Integer idAgrupacion) {
		Agrupaciones agrupaciones = new Agrupaciones();
		agrupaciones.setIdAgrupacion(idAgrupacion);
		this.agrupacionesService.remove(agrupaciones);
		AgrupacionesController.logger.info("[DELETE] : Agrupaciones borrado correctamente");
		return agrupaciones;
	}

	/*
	 * METODOS COMPONENTE RUP_TABLE
	 * 
	 */

	/**
	 * Metodo de presentacion del RUP_TABLE.
	 * 
	 * @param model
	 *            Model
	 * @return String
	 */
	@RequestMapping(value = "/maint", method = RequestMethod.GET)
	public String getFormEdit(Model model) {
		AgrupacionesController.logger.info("[GET - View] : agrupaciones");
		return "agrupaciones";
	}

	/**
	 * Operacion de filtrado del componente RUP_TABLE.
	 * 
	 * @param filterAgrupaciones
	 *            Agrupaciones Bean que contiene los parametros de filtrado a
	 *            emplear.
	 * @param tableRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en el filtrado.
	 * @return TableResponseDto<Agrupaciones> Dto que contiene el resultado del
	 *         filtrado realizado por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/filter", method = RequestMethod.POST)
	public @ResponseBody TableResponseDto<Agrupaciones> filter(
			@RequestJsonBody(param = "filter") Agrupaciones filterAgrupaciones,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		AgrupacionesController.logger.info("[POST - filter] : Obtener Agrupacioness");
		return this.agrupacionesService.filter(filterAgrupaciones, tableRequestDto, false);
	}

}
